/*
 *  Main.cpp
 *  AudioDrome
 *
 *  Created by Alessandro Petrolati on 21/08/08.
 *  Copyright 2008 www.alessandro-petrolati.it All rights reserved.
 *
 */

#include "AudioDromeAll.h"

using namespace Aud;
using namespace std;


/* ............................................:::: CIM TEST 0 ::::............................................ */
/* Realt Time DAC Output */
/* Hello grano! comiled with AudioDrome Portaudio V19 Debug or Release target */


//int main(int argc, char ** argv)
//{
//	std::cout << "Hello grano!"<< std::endl
//	<<"www.alessandro-petrolati.it"<< std::endl << std::endl
//	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
//	
//	AudioDrome::setAbsoluteSR(44100);
//	
//	AudioOut dac;
//	Granulator gr;
//	
//	ul P3 = AudioDrome::getAbsoluteSR() * 7.f;
//	
//	for (ul i = 0; i < P3 ; i++)
//	{
//		gr.PROCESSING();
//		dac.PROCESSING();
//		
//		dac.Input( gr.Output() );
//		dac.Input_2(gr.Output_2() );
//		//or simply:
//		//		dac << gr;
//	}
//	dac.abortStream();
//	return 0;
//}


/* ............................................:::: CIM TEST 1 ::::............................................ */
/* Realt Time DAC Output with CallBack routine */
/* Hello grano! comiled with AudioDrome Portaudio V19 Debug or Release target */

//int MyCallback(const void *input, void *output, unsigned long frameCount,
//			   const PaStreamCallbackTimeInfo* timeInfo, 
//			   PaStreamCallbackFlags statusFlags, void *userData )
//{
//	Granulator* gr = static_cast<Granulator*>(userData);
//	
//	(void) input; // Prevent unused variable warning. 
//
//	PaFloat *out = (PaFloat*) output;
//	
//	for( unsigned int i = 0; i < frameCount; i++ )
//	{
//		gr->PROCESSING();
//		*out++ = gr->Output();
//		*out++ = gr->Output_2();
//	}
//	return 0;
//}		
//
//int main(int argc, char ** argv)
//{
//	std::cout << "Hello CallBack grano!"<< std::endl
//	<<"www.alessandro-petrolati.it"<< std::endl << std::endl
//	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
//	
//	AudioDrome::setAbsoluteSR(44100);
//
//	AudioOut dac;
//	Granulator gr;
//	gr.setWidth(1);
//	
//	dac.setStreamCallBack(&MyCallback, &gr);
//	
//	dac.sleep(6000); // Running for six seconds
//	
//	dac.abortStream();
//	return true;
//}


/* ............................................:::: CIM TEST 2 ::::............................................ */
/* Realt Time EuVerb In/Out in the soudd board and/or audio file */
/* EUVerb comiled with AudioDrome Portaudio V19 Debug or Release target */

//#include "FileWvIn.h"
//#include "FileWvOut.h"
//
//
//int main(int argc, char ** argv)
//{
//	///Show header
//	std::cout << "EUVerb" << std::endl << "Modelling by Eugenio Giordani" << std::endl << "Implementation by Alessandro Petrolati: AudioDrome C++ Classes"<< std::endl
//	<<"www.eugenio-giordani.it" << std::endl << "www.alessandro-petrolati.it"<< std::endl<< "info@eugenio-giordani.it" << std::endl
//	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
//	
//	AudioDrome::setAbsoluteSR(44100);
//	Stk::setSampleRate( AudioDrome::getAbsoluteSR() );
//	
//	FileWvIn fileIn("/Users/alessandropetrolati/Desktop/Prelude.wav");
//	FileWvOut fileOut("/Users/alessandropetrolati/Desktop/EuVerbTest.wav", 2, FileWrite::FILE_WAV, Stk::STK_SINT16, 2);
//	
//	EUVerb euv;
//	euv.setT60(1.8);
//	euv.setInperpolation(LINEAR);
//	euv.setReverberatedLevel(0.3);
//	euv.setDirectLevel(0.7);
//	euv.setDirectDelay(0.9);
//	
//	AudioIn adc;			
//	AudioOut dac;
//	
//	ul P3 = AudioDrome::getAbsoluteSR() * 1100;
//	
//	for (ul i = 0; i < P3; i++)
//	{
//		adc.PROCESSING();
//		dac.PROCESSING();
//		euv.PROCESSING();
//		
//		/* RealTime IO */
//		euv.Input( adc.Output() );
//		euv.Input_2(adc.Output_2() );
//		dac.Input( euv.Output() );
//		dac.Input_2( euv.Output_2() );
//		
//		//or simply:
//		//		dac << euv << adc;
//		//		yet
//		////		adc >> euv >> dac;
//		
//		/* Process file Input and write in the file output*/
//		/*
//		 dac << (euv << fileIn.tick());
//		 fileOut.tick( euv.Output() );
//		 */
//		
//	}
//	adc.abortStream();
//	dac.abortStream();
//	
//	return true;
//}


/* ............................................:::: CIM TEST 3 ::::............................................ */
/* Realt Time FullDuplex with Callback */
/* Comiled with AudioDrome Portaudio V19 Debug or Release target */

//int MyCallback(const void *input, void *output, unsigned long frameCount,
//			   const PaStreamCallbackTimeInfo* timeInfo, 
//			   PaStreamCallbackFlags statusFlags, void *userData )
//{	
//	(void)(userData);// Prevent unused variable warning. 
//	
//	PaFloat *out = (PaFloat*) output;
//	PaFloat *in = (PaFloat*) input;
//	
//	for( unsigned int i = 0; i < frameCount; i++ )
//	{
//		*out++ = *in++;
//		*out++ = *in++;
//	}
//	return 0;
//}		
//
//int main(int argc, char ** argv)
//{
//	std::cout << "Full Duplex audio with callback!"<< std::endl
//	<<"www.alessandro-petrolati.it"<< std::endl << std::endl
//	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
//	
//	AudioDrome::setAbsoluteSR(44100);
//	
//	AudioDuplex io;
//	io.setStreamCallBack(&MyCallback, NULL);
//	
//	io.sleep(60000);
//	io.abortStream();
//	
//	return 0;
//}

/* ............................................:::: CIM TEST 4 ::::............................................ */
/* Realt Time FullDuplex EUVerb with Callback */
/* Comiled with AudioDrome Portaudio V19 Debug or Release target */

//int MyCallback(const void *input, void *output, unsigned long frameCount,
//			   const PaStreamCallbackTimeInfo* timeInfo, 
//			   PaStreamCallbackFlags statusFlags, void *userData )
//{	
//	EUVerb* euv = (EUVerb*)(userData);
//	
//	PaFloat *out = (PaFloat*) output;
//	PaFloat *in = (PaFloat*) input;
//	
//	for( unsigned int i = 0; i < frameCount; i++ )
//	{
//		euv->PROCESSING();
//		euv->Input(*in++);
//		
//		*in++; //rigth channel not used like input for this DSP
//		
//		*out++ = euv->Output();
//		*out++ = euv->Output_2();
//	}
//	return 0;
//}		
//
//int main(int argc, char ** argv)
//{
//	std::cout << "Full Duplex EUVerb with callback!"<< std::endl
//	<<"www.alessandro-petrolati.it"<< std::endl << std::endl
//	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
//	
//	AudioDrome::setAbsoluteSR(44100);
//	
//	AudioDuplex io;
//	EUVerb euv;
//	
//	io.setStreamCallBack(&MyCallback, &euv);
//	
//	io.sleep(1000000);
//	
//	io.abortStream();
//	return 0;
//}

/* ............................................:::: CIM TEST 5 ::::............................................ */
/* Downsampling and Sampling Rate changing Notify */
/* Comiled with AudioDrome Portaudio V19 Debug or Release target */

#include "FileWvIn.h"
#include "FileWvOut.h"

int main(int argc, char ** argv)
{
	std::cout << "Downsampling and Sampling Rate changing Notify!"<< std::endl
	<<"www.alessandro-petrolati.it"<< std::endl << std::endl
	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
	
	AudioDrome::setAbsoluteSR(48000);
	Stk::setSampleRate( AudioDrome::getAbsoluteSR() );
	
	FileWvIn fileIn("/Users/alessandropetrolati/Desktop/Prelude.wav");
	FileWvOut fileOut("/Users/alessandropetrolati/Desktop/AudioDromeTest.wav", 2, FileWrite::FILE_WAV, Stk::STK_SINT16, 2);
	
	Granulator grn;
	grn.setDownSampling(10);
	Metronome mt(false);
	mt.setFrequency(1);
	
	AudioIn adc;			
	AudioOut dac;

	ul P3 = AudioDrome::getAbsoluteSR() * 5;
	
	for (ul i = 0; i < P3; i++)
	{
		adc.PROCESSING();
		dac.PROCESSING();
		grn.PROCESSING();
		mt.PROCESSING();

		if(mt[LEFT])
		{
//			grn.setDownSampling(20);
			AudioDrome::setAbsoluteSR(32000);
		}
		
		dac << grn;
		
//		fileOut.tick( grn.Output() );

	}
	adc.abortStream();
	dac.abortStream();
	return 0;
}


//int main(int argc, char ** argv)
//{
//	std::cout << "Sampling Rate is Changing"<< std::endl
//	<<"www.alessandro-petrolati.it"<< std::endl << std::endl
//	<<"info@alessandro-petrolati.it" << std::endl << std::endl;
//	
//	AudioDrome::setAbsoluteSR(48000);
//	
//	AudioOut dac;
//	
//	Oscillator lfo;
//	lfo.setAmplitude(0.5);
//	lfo.setFrequency(3);
//	lfo.setDownSampling(500);
//	UpSampling up(lfo);
//	
//	Oscillator osc;
//	osc.setFrequency(440);	
//	
//	ul P3 = AudioDrome::getAbsoluteSR() * 5;
//	
//	for (ul i = 0; i < P3; i++)
//	{
//		dac.PROCESSING();
//		lfo.PROCESSING();
//		osc.PROCESSING();
//		up.PROCESSING();
//		
//		
//		up << lfo;
//		osc.setAmplitude( up.Output() + 0.5 );
//		dac << osc;
//	}
//	
//	dac.abortStream();
//	
//	return true;
//}

/////EOF