/***************************************************/
/*! \class myClassTemplate
 \brief
 
 The AudioDrome myClassTemplate class, implements ...
 
 by Author 2008.
 www.myweb.it
 info@mymail.com
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.
 
 You should have received a copy of the GNU Library General Public
 License along with this library; if not, write to the Free
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/***************************************************/

#ifndef MYCLASSTEMPLATE_H
#define MYCLASSTEMPLATE_H

#include "AudioDrome.h"

//  begin namespace
namespace Aud
{
	class myClassTemplate : public AudioDrome //or a sub-class
		{
		public:
			//! Public constructor
			myClassTemplate();
			
			//! Public destructor
			virtual ~myClassTemplate();
			
			//! Sets or gets ...
			/*!
			 * if you need to upgrade the class variables, dependent on _localSR
			 */
			void myMemberFunction(const AudFloat &val=0) /*! Sampling Rate Change SLOT */
			{
			}
			
			/* You can read or write the sample in the DSP
			 * with the virtual Output() or Input functions.
			 * Also you can redefined.
			 */
			//			virtual AudFloat Output();
			//			virtual void Input(const AudFloat& input);
			
		protected:
			//! Processing the audio sample
			/*!
			 * ...
			 */
			virtual void Processing();
			
			virtual void srUpdate()
			{ 
				this->myMemberFunction();  /*! Sampling Rate Changing SLOT */
			}
			//my class variables
		};
} //	end of namespace Aud
#endif
///EOF
